aniwrapper/ani-cli

317 lines
6.8 KiB
Plaintext
Raw Normal View History

2021-06-09 05:25:23 -07:00
#!/bin/sh
2021-06-15 08:16:30 -07:00
# dependencies: grep sed curl video_player
2021-06-13 04:54:19 -07:00
# video_player ( needs to be able to play urls )
player_fn="mpv"
2021-06-09 05:25:23 -07:00
prog="ani-cli"
logfile="${XDG_CACHE_HOME:-$HOME/.cache}/ani-hsts"
2021-06-09 05:25:23 -07:00
2021-06-09 08:53:30 -07:00
c_red="\033[1;31m"
c_green="\033[1;32m"
c_yellow="\033[1;33m"
c_blue="\033[1;34m"
c_magenta="\033[1;35m"
c_cyan="\033[1;36m"
c_reset="\033[0m"
2021-06-10 03:48:06 -07:00
2021-06-09 05:25:23 -07:00
help_text () {
while IFS= read line; do
printf "%s\n" "$line"
done <<-EOF
USAGE: $prog <query>
-h show this help text
-d download episode
-H continue where you left off
2021-06-09 05:25:23 -07:00
EOF
}
die () {
2021-06-11 06:40:54 -07:00
printf "$c_red%s$c_reset\n" "$*" >&2
2021-06-09 05:25:23 -07:00
exit 1
}
err () {
printf "$c_red%s$c_reset\n" "$*" >&2
}
2021-06-09 05:25:23 -07:00
search_anime () {
# get anime name along with its id
search=$1
titlepattern='<a href="/category/'
curl -s "https://gogoanime.vc//search.html" \
-G \
-d "keyword=$search" |
sed -n -E '
s_^[[:space:]]*<a href="/category/([^"]*)" title="([^"]*)".*_\1_p
'
}
search_eps () {
# get available episodes for anime_id
anime_id=$1
curl -s "https://gogoanime.vc/category/$anime_id" |
sed -n -E '
/^[[:space:]]*<a href="#" class="active" ep_start/{
s/.* '\''([0-9]*)'\'' ep_end = '\''([0-9]*)'\''.*/\2/p
q
}
'
}
get_links () {
# get the download page url
anime_id=$1
ep_no=$2
dpage_url=$(
curl -s "https://gogoanime.vc/$anime_id-episode-$ep_no" |
2021-07-16 05:13:09 -07:00
sed -n -E 's_^[[:space:]]*<a href="#" rel="100" data-video="([^"]*)" >.*_https:\1_p')
2021-06-09 05:25:23 -07:00
curl -s "$dpage_url" |
2021-07-16 05:13:09 -07:00
sed -n -E "s/^[[:space:]]*sources:\[\{file\: '([^']*)'.*/\1/p" | sed 1q
2021-06-09 05:25:23 -07:00
}
2021-06-11 06:18:20 -07:00
dep_ch () {
for dep; do
if ! command -v "$dep" >/dev/null ; then
die "Program \"$dep\" not found. Please install it."
fi
done
}
# get query
get_search_query () {
if [ -z "$*" ]; then
printf "Search Anime: "
read -r query
else
query=$*
fi
}
# create history file
[ -f "$logfile" ] || : > "$logfile"
#####################
## Anime selection ##
#####################
2021-06-09 05:25:23 -07:00
anime_selection () {
search_results=$*
menu_format_string='[%d] %s\n'
menu_format_string_c1="$c_blue[$c_cyan%d$c_blue] $c_reset%s\n"
menu_format_string_c2="$c_blue[$c_cyan%d$c_blue] $c_yellow%s$c_reset\n"
count=1
while read anime_id; do
# alternating colors for menu
[ $((count % 2)) -eq 0 ] &&
menu_format_string=$menu_format_string_c1 ||
menu_format_string=$menu_format_string_c2
printf "$menu_format_string" "$count" "$anime_id"
count=$((count+1))
done <<-EOF
$search_results
EOF
# User input
printf "$c_blue%s$c_green" "Enter number: "
read choice
printf "$c_reset"
# Check if input is a number
[ "$choice" -eq "$choice" ] 2>/dev/null || die "Invalid number entered"
2021-06-09 05:25:23 -07:00
# Select respective anime_id
count=1
while read anime_id; do
if [ $count -eq $choice ]; then
selection_id=$anime_id
break
fi
count=$((count+1))
done <<-EOF
$search_results
EOF
[ -z "$selection_id" ] && die "Invalid number entered"
read last_ep_number <<-EOF
$(search_eps "$selection_id")
EOF
}
2021-06-09 05:25:23 -07:00
##################
## Ep selection ##
##################
episode_selection () {
[ $is_download -eq 1 ] &&
printf "Range of episodes can be specified: start_number end_number\n"
2021-06-09 05:25:23 -07:00
printf "${c_blue}Choose episode $c_cyan[1-%d]$c_reset:$c_green " $last_ep_number
read ep_choice_start ep_choice_end
printf "$c_reset"
2021-06-09 05:25:23 -07:00
}
2021-06-09 05:25:23 -07:00
open_episode () {
anime_id=$1
episode=$2
2021-06-09 05:25:23 -07:00
2021-07-16 05:13:09 -07:00
# clear the screen
printf '\x1B[2J\x1B[1;1H'
if [ $episode -lt 1 ] || [ $episode -gt $last_ep_number ]; then
err "Episode out of range"
printf "${c_blue}Choose episode $c_cyan[1-%d]$c_reset:$c_green " $last_ep_number
read episode
printf "$c_reset"
2021-06-09 05:25:23 -07:00
fi
printf "Getting data for episode %d\n" $episode
2021-06-09 05:25:23 -07:00
video_url=$(get_links "$anime_id" "$episode")
2021-06-09 05:25:23 -07:00
case $video_url in
2021-06-09 07:56:57 -07:00
*streamtape*)
2021-06-09 14:49:28 -07:00
# If direct download not available then scrape streamtape.com
2021-06-09 05:25:23 -07:00
BROWSER=${BROWSER:-firefox}
2021-06-09 07:56:57 -07:00
printf "scraping streamtape.com\n"
video_url=$(curl -s "$video_url" | sed -n -E '
/^<script>document/{
s/^[^"]*"([^"]*)" \+ '\''([^'\'']*).*/https:\1\2\&dl=1/p
q
}
');;
2021-06-09 05:25:23 -07:00
esac
2021-06-10 03:48:06 -07:00
if [ $is_download -eq 0 ]; then
# write anime and episode number
2021-06-17 23:53:06 -07:00
sed -E "
s/^${selection_id}\t[0-9]+/${selection_id}\t$((episode+1))/
" "$logfile" > "${logfile}.new" && mv "${logfile}.new" "$logfile"
setsid -f $player_fn "$video_url" >/dev/null 2>&1
2021-06-10 03:48:06 -07:00
else
printf "Downloading episode $episode ...\n"
2021-06-10 03:48:06 -07:00
printf "%s\n" "$video_url"
# add 0 padding to the episode name
episode=$(printf "%03d" $episode)
2021-06-10 03:48:06 -07:00
{
curl -L -# -C - "$video_url" -o "${anime_id}-${episode}.mp4" &&
printf "${c_green}Downloaded episode: %s${c_reset}\n" "$episode" ||
printf "${c_red}Download failed episode: %s${c_reset}\n" "$episode"
2021-06-10 03:48:06 -07:00
}
fi
}
############
# Start Up #
############
2021-06-21 09:23:15 -07:00
# to clear the colors when exited using SIGINT
trap "printf '$c_reset'" INT HUP
dep_ch "$player_fn" "curl" "sed" "grep"
# option parsing
is_download=0
scrape=query
while getopts 'hdH' OPT; do
case $OPT in
h)
help_text
exit 0
;;
d)
is_download=1
;;
H)
scrape=history
;;
esac
done
shift $((OPTIND - 1))
########
# main #
########
case $scrape in
query)
get_search_query "$*"
search_results=$(search_anime "$query")
[ -z "$search_results" ] && die "No search results found"
anime_selection "$search_results"
episode_selection
;;
history)
search_results=$(sed -n -E 's/\t[0-9]*//p' "$logfile")
[ -z "$search_results" ] && die "History is empty"
anime_selection "$search_results"
ep_choice_start=$(sed -n -E "s/${selection_id}\t//p" "$logfile")
;;
esac
{ # checking input
[ "$ep_choice_start" -eq "$ep_choice_start" ] 2>/dev/null || die "Invalid number entered"
episodes=$ep_choice_start
if [ -n "$ep_choice_end" ]; then
[ "$ep_choice_end" -eq "$ep_choice_end" ] 2>/dev/null || die "Invalid number entered"
# create list of episodes to download/watch
episodes=$(seq $ep_choice_start $ep_choice_end)
fi
}
# add anime to history file
grep -q -w "${selection_id}" "$logfile" ||
printf "%s\t%d\n" "$selection_id" $((episode+1)) >> "$logfile"
2021-06-13 04:54:19 -07:00
for ep in $episodes
do
open_episode "$selection_id" "$ep"
done
episode=${ep_choice_end:-$ep_choice_start}
while :; do
2021-06-13 04:54:19 -07:00
printf "\n${c_green}Currently playing %s episode ${c_cyan}%d/%d\n" "$selection_id" $episode $last_ep_number
2021-06-09 08:53:30 -07:00
printf "$c_blue[${c_cyan}%s$c_blue] $c_yellow%s$c_reset\n" "n" "next episode"
printf "$c_blue[${c_cyan}%s$c_blue] $c_magenta%s$c_reset\n" "p" "previous episode"
2021-06-20 23:00:06 -07:00
printf "$c_blue[${c_cyan}%s$c_blue] $c_yellow%s$c_reset\n" "s" "select episode"
2021-06-09 08:53:30 -07:00
printf "$c_blue[${c_cyan}%s$c_blue] $c_red%s$c_reset\n" "q" "exit"
2021-06-09 14:49:28 -07:00
printf "${c_blue}Enter choice:${c_green} "
read choice
2021-06-09 08:53:30 -07:00
printf "$c_reset"
2021-06-09 05:25:23 -07:00
case $choice in
2021-06-09 14:49:28 -07:00
n)
2021-06-13 04:54:19 -07:00
episode=$((episode + 1))
2021-06-09 05:25:23 -07:00
;;
p)
2021-06-13 04:54:19 -07:00
episode=$((episode - 1))
2021-06-09 05:25:23 -07:00
;;
2021-06-20 23:00:06 -07:00
s) printf "${c_blue}Choose episode $c_cyan[1-%d]$c_reset:$c_green " $last_ep_number
read episode
printf "$c_reset"
[ "$episode" -eq "$episode" ] 2>/dev/null || die "Invalid number entered"
2021-06-20 23:00:06 -07:00
;;
2021-07-16 05:13:09 -07:00
q)
2021-06-10 03:48:06 -07:00
break;;
2021-06-20 23:00:06 -07:00
2021-06-09 05:25:23 -07:00
*)
die "invalid choice"
;;
esac
2021-06-13 04:54:19 -07:00
open_episode "$selection_id" "$episode"
2021-06-09 05:25:23 -07:00
done